/* Feb 8/91- Taken from Bjarne Stroustrup book C ++ 						*/
/* Capilano Computing Systems Limited.										*/

  
/* This is a pure virtual List */
/* You must derive a realy list from it */

#ifndef LIST_H
#define LIST_H

#include "ListObj.h"
#include "Object.h"

class TList : public TObject
{

	protected:
		long		fNumberOfObjectsOnList;
	
	
	public:

		TList();
		
	
		// return number of elements in list
		
		virtual long NumElements();

	// All the rest of the Methods are Pure Virtual Functions and
	// have to be defined in the Derived Class
		
		// clear list to empty state
		
		virtual void Clear()=0;
		
		virtual int IsEmpty()=0;
	
		
		//set current pointer to the ends of the list
	
		virtual void Reset()=0;
		
		
		// move around the list, leaving the links there
	
		virtual int Next (TListObject** e) =0;
		virtual int Prev (TListObject** e) =0;
	
		//manipulate around the list, removing the links
	
		virtual int GetNext(TListObject** e) =0;
		virtual int GetPrev(TListObject** e) =0;
	
		//manipulate around the beginning
		// and end of the list
	
		virtual void Insert(TListObject* e) =0;
		virtual void Append(TListObject* e)  =0;
	
		// manipulate around the current entry
	
		virtual void InserThere(TListObject* e ) =0;
		virtual void AppendHere(TListObject* e) =0;
};


#endif